#include "AI8051U.h"
#include "stdio.h"
#include "intrins.h"
#include "font.h"
#include <absacc.h>
#include <string.h>

#define uchar unsigned char
#define uint unsigned int



#define MAIN_Fosc        24000000UL

//==========================================================================


/*************  س    **************/
//峣ɫ
#define RED  		0xf800
#define GREEN		0x07e0
#define BLUE 		0x001f
#define WHITE		0xffff
#define BLACK		0x0000
#define YELLOW  0xFFE0
#define GRAY0   0xEF7D
#define GRAY1   0x8410
#define GRAY2   0x4208

/*************  IOڶ    **************/

sbit scl       =P4^3;	//ģSCL,Pin9_SCL
sbit sda       =P4^1;	//ģSDAţPin8_SDA
sbit rs        =P1^1;	//ģDCţPin7_A0
sbit cs        =P4^0;	//ģCSţPin12_CS
sbit reset     =P4^7;	//ģRESţPin6_RES
sbit IO_BK     =P4^5;	

/*
sbit scl       =P1^7;	//ģSCL,Pin9_SCL 
sbit sda       =P1^5;	//ģSDAţPin8_SDA  
sbit rs        =P1^6;	//ģDCţPin7_A0  
sbit cs        =P1^4;	//ģCSţPin12_CS  
sbit reset     =P4^7;	//ģRESţPin6_RES  
sbit IO_BK     =P4^5;	 
*/

void  Contrast_Adjust();
code  typFNT_GBK16 hz16[];
void Output_Pixel(uint x,uint y);
void delay_ms(uint time)
{
 uint i,j;
  for(i=0;i<time;i++)
   for(j=0;j<250;j++);
}

//SPIߴһ8λ
void  SPI_WriteData(uchar Data)
{
	unsigned char i=0;
	for(i=8;i>0;i--)
	{
		if(Data&0x80)
		sda=1; //
		else sda=0;
		scl=0;
		scl=1;
		Data<<=1;
	}
}
//Һдһ8λָ
void  Lcd_WriteIndex(uchar Data)
{

		cs=0;
		rs=0;
		SPI_WriteData(Data);
		cs=1;
}
//Һдһ8λ
void  Lcd_WriteData(uchar Data)
{
		unsigned char i=0;
		cs=0;
		rs=1;
		SPI_WriteData(Data);
		cs=1;
}
//Һдһ16λ
void  LCD_WriteData_16Bit(unsigned int Data)
{
	unsigned char i=0;
	cs=0;
	rs=1;
	SPI_WriteData(Data>>8); 	//д8λ
	SPI_WriteData(Data); 			//д8λ
	cs=1;

}

void Reset()
{
    reset=0;
    delay_ms(100);
    reset=1;
    delay_ms(100);
}
//////////////////////////////////////////////////////////////////////////////////////////////
//Һʼ
void lcd_initial()
{	Reset();//Reset before LCD Init.
	Lcd_WriteIndex(0x11);//Sleep exit
	delay_ms (120);
	Lcd_WriteIndex(0x21);
Lcd_WriteIndex(0x21);

Lcd_WriteIndex(0xB1);
Lcd_WriteData(0x05);
Lcd_WriteData(0x3A);
Lcd_WriteData(0x3A);

Lcd_WriteIndex(0xB2);
Lcd_WriteData(0x05);
Lcd_WriteData(0x3A);
Lcd_WriteData(0x3A);

Lcd_WriteIndex(0xB3);
Lcd_WriteData(0x05);
Lcd_WriteData(0x3A);
Lcd_WriteData(0x3A);
Lcd_WriteData(0x05);
Lcd_WriteData(0x3A);
Lcd_WriteData(0x3A);

Lcd_WriteIndex(0xB4);
Lcd_WriteData(0x03);

Lcd_WriteIndex(0xC0);
Lcd_WriteData(0x62);
Lcd_WriteData(0x02);
Lcd_WriteData(0x04);

Lcd_WriteIndex(0xC1);
Lcd_WriteData(0xC0);

Lcd_WriteIndex(0xC2);
Lcd_WriteData(0x0D);
Lcd_WriteData(0x00);

Lcd_WriteIndex(0xC3);
Lcd_WriteData(0x8D);
Lcd_WriteData(0x6A);

Lcd_WriteIndex(0xC4);
Lcd_WriteData(0x8D);
Lcd_WriteData(0xEE);

Lcd_WriteIndex(0xC5);  /*VCOM*/
Lcd_WriteData(0x0E);

Lcd_WriteIndex(0xE0);
Lcd_WriteData(0x10);
Lcd_WriteData(0x0E);
Lcd_WriteData(0x02);
Lcd_WriteData(0x03);
Lcd_WriteData(0x0E);
Lcd_WriteData(0x07);
Lcd_WriteData(0x02);
Lcd_WriteData(0x07);
Lcd_WriteData(0x0A);
Lcd_WriteData(0x12);
Lcd_WriteData(0x27);
Lcd_WriteData(0x37);
Lcd_WriteData(0x00);
Lcd_WriteData(0x0D);
Lcd_WriteData(0x0E);
Lcd_WriteData(0x10);

Lcd_WriteIndex(0xE1);
Lcd_WriteData(0x10);
Lcd_WriteData(0x0E);
Lcd_WriteData(0x03);
Lcd_WriteData(0x03);
Lcd_WriteData(0x0F);
Lcd_WriteData(0x06);
Lcd_WriteData(0x02);
Lcd_WriteData(0x08);
Lcd_WriteData(0x0A);
Lcd_WriteData(0x13);
Lcd_WriteData(0x26);
Lcd_WriteData(0x36);
Lcd_WriteData(0x00);
Lcd_WriteData(0x0D);
Lcd_WriteData(0x0E);
Lcd_WriteData(0x10);

Lcd_WriteIndex(0x3A);
Lcd_WriteData(0x05);

Lcd_WriteIndex(0x36);
Lcd_WriteData(0xC8);

Lcd_WriteIndex(0x29);

}

/*************************************************
LCD_Set_Region
ܣlcdʾڴдԶ
ڲxyյ
ֵ
*************************************************/
void Lcd_SetRegion(unsigned int x_start,unsigned int y_start,unsigned int x_end,unsigned int y_end)
{

	Lcd_WriteIndex(0x2a);
	Lcd_WriteData(0x00);
	Lcd_WriteData(x_start	+0x18);//+0x18
	Lcd_WriteData(0x00);
	Lcd_WriteData(x_end		+0x18);//+0x18

	Lcd_WriteIndex(0x2b);
	Lcd_WriteData(0x00);
	Lcd_WriteData(y_start);
	Lcd_WriteData(0x00);
	Lcd_WriteData(y_end);
	Lcd_WriteIndex(0x2c);
}

void PutPixel(uint x_start,uint y_start,uint color)
{
	Lcd_SetRegion(x_start,y_start,x_start+1,y_start+1);
	LCD_WriteData_16Bit(color);

}

void dsp_single_colour(int color)
{
 	uchar i,j;
	Lcd_SetRegion(0,0,80-1,160-1);
 	for (i=0;i<160;i++)
    	for (j=0;j<80;j++)
        	LCD_WriteData_16Bit(color);
}

//ôڷֿݣGui_DrawFont_GBK16
void Fast_DrawFont_GBK16(uint x, uint y, uint fc, uint bc, uchar *s)
{
	unsigned char i,j;
	unsigned short k;
	uint HZnum;
	HZnum=sizeof(hz16)/sizeof(typFNT_GBK16);
	while(*s)
	{
		if((*s) >= 128)
		{
			for (k=0;k<HZnum;k++)
			{
			  if ((hz16[k].Index[0]==*(s))&&(hz16[k].Index[1]==*(s+1)))
			  { 	Lcd_SetRegion(x,y,x+16-1,y+16-1);
				    for(i=0;i<16*2;i++)
				    {
						for(j=0;j<8;j++)
				    	{
							if(hz16[k].Msk[i]&(0x80>>j))	LCD_WriteData_16Bit(fc);
							else
							{
							if (fc!=bc) LCD_WriteData_16Bit(bc);
							}
						}
					}


				}
			}
		s+=2;x+=16;
		}


		else
		s+=1;

	}
}
//˷溺ֽ
void Gui_DrawFont_GBK16(uint x, uint y, uint fc, uint bc, uchar *s)
{
	unsigned char i,j;
	unsigned short k,x0;
	x0=x;

	while(*s)
	{
		if((*s) >= 128)
		{
			for (k=0;k<hz16_num;k++)
			{
			  if ((hz16[k].Index[0]==*(s))&&(hz16[k].Index[1]==*(s+1)))
			  {
				    for(i=0;i<16;i++)
				    {
						for(j=0;j<8;j++)
							{
						    	if(hz16[k].Msk[i*2]&(0x80>>j))	PutPixel(x+j,y+i,fc);
								else {
									if (fc!=bc) PutPixel(x+j,y+i,bc);
								}
							}
						for(j=0;j<8;j++)
							{
						    	if(hz16[k].Msk[i*2+1]&(0x80>>j))	PutPixel(x+j+8,y+i,fc);
								else
								{
									if (fc!=bc) PutPixel(x+j+8,y+i,bc);
								}
							}
				    }
				}
			  }
			s+=2;x+=16;
		}
		else
		s+=1;

	}
}

void Font_Test(void)
{//ʾԽݳӻӭΪרҵע
	dsp_single_colour(WHITE);
	Fast_DrawFont_GBK16(8,10,BLUE,YELLOW,	"");
	Fast_DrawFont_GBK16(0,30,RED,WHITE,	"ݳ");
	Fast_DrawFont_GBK16(16,50,BLUE,WHITE,	"ӭ");
	Fast_DrawFont_GBK16(8,70,WHITE,BLUE, 	"Ϊרע");
	Fast_DrawFont_GBK16(8,90,WHITE,BLUE,	"רҵ");

	delay_ms(180);//1800
}

void Font_Test2(void)
{
	dsp_single_colour(WHITE);
}
/********************  **************************/
void main(void)
{
    WTST = 0;  //óָʱֵΪ0ɽCPUִָٶΪ
    EAXFR = 1; //չĴ(XFR)ʹ
    CKCON = 0; //߷XRAMٶ

    P0M1 = 0x00;   P0M0 = 0x00;   //Ϊ
    P1M1 = 0x00;   P1M0 = 0x00;   //Ϊ׼˫
    P2M1 = 0x00;   P2M0 = 0x00;   //Ϊ׼˫
    P3M1 = 0x00;   P3M0 = 0x00;   //Ϊ׼˫
    P4M1 = 0x00;   P4M0 = 0x00;   //Ϊ׼˫
    P5M1 = 0x00;   P5M0 = 0x00;   //Ϊ׼˫
    P6M1 = 0x00;   P6M0 = 0x00;   //Ϊ׼˫
    P7M1 = 0x00;   P7M0 = 0x00;   //Ϊ׼˫
	
	IO_BK = 1;
    lcd_initial();
	Font_Test();
	delay_ms(500);
	//dsp_single_colour(WHITE);


    while(1)
    {

    }
}

